/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#define FE_OST_IO_DEBUG		FALSE

#include "operator/operator.pmh"

using namespace fe;

BWORD OperatorState::saveState(String& rBuffer)
{
#if FE_OST_IO_DEBUG
	feLog("OperatorState::saveState\n");
#endif

	sp<data::StreamI> spStream(new data::AsciiStream(m_spScope));
	std::ostringstream streamOut;
	spStream->output(streamOut,m_spState);

	std::stringbuf* pStringBuf=streamOut.rdbuf();
	rBuffer=pStringBuf->str().c_str();

#if FE_OST_IO_DEBUG
	feLog("---------\n");
	feLog("%s",rBuffer.c_str());
	feLog("---------\n");
#endif

	return TRUE;
}

BWORD OperatorState::loadState(const String& rBuffer)
{
#if FE_OST_IO_DEBUG
	feLog("OperatorState::loadState\n");
	feLog("---------\n");
	feLog("%s",rBuffer.c_str());
	feLog("---------\n");
#endif

	m_spScope=registry()->create("Scope");
	m_spScope->setName(name()+".State");
	m_spState=new RecordGroup();

	setupState();

	std::string stringIn=rBuffer.c_str();
	std::istringstream streamIn(stringIn);

	sp<data::StreamI> spStream(new data::AsciiStream(m_spScope));
	sp<RecordGroup> spLoadedGroup=spStream->input(streamIn);

	if(spLoadedGroup.isValid())
	{
		m_spState=spLoadedGroup;
	}

	return TRUE;
}
