/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_OperatorState_h__
#define __operator_OperatorState_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator base class to save and reload state

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT OperatorState:
	virtual public OperatorSurfaceCommon
{
	public:

							OperatorState(void)								{}
virtual						~OperatorState(void)							{}

							//* As OperatorSurfaceI
virtual	BWORD				saveState(String& rBuffer);
virtual	BWORD				loadState(const String& rBuffer);

	protected:

virtual	void				setupState(void)								{}

		sp<Scope>			m_spScope;
		sp<RecordGroup>		m_spState;
};

} /* namespace */

#endif /* __operator_OperatorState_h__ */
