/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __grass_OperatorThreaded_h__
#define __grass_OperatorThreaded_h__

namespace fe
{

/**************************************************************************//**
	@brief Handler to move curves away from a collider

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT OperatorThreaded:
	virtual public OperatorSurfaceCommon,
	public Initialize<OperatorThreaded>
{
	public:

	class Range
	{
		public:
					Range(void):
						m_start(-1),
						m_end(-1)											{}
			I32	m_start;
			I32	m_end;
	};

					OperatorThreaded(void):
						m_threadsAlive(0)									{}
virtual				~OperatorThreaded(void);

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

virtual	void		run(I32 a_id,Range a_range)								=0;

		void		setFullRange(I32 a_start,I32 a_end)
					{
						m_fullRange.m_start=a_start;
						m_fullRange.m_end=a_end;
					}

	private:
		void		finish(void);

	class Worker
	{
		public:
						Worker(U32 id,sp< JobQueue<Range> > spJobQueue):
							m_id(id),
							m_spJobQueue(spJobQueue)						{}

			void		operator()(void);

			void		setObject(sp<Counted> spObject)
						{	m_spOperatorThreaded=spObject; }

		private:
			U32						m_id;
			sp< JobQueue<Range> >	m_spJobQueue;
			sp<OperatorThreaded>	m_spOperatorThreaded;
	};

		Range						m_fullRange;

		sp< Gang<Worker,Range> >	m_spGang;
		U32							m_threadsAlive;
};

} /* namespace */

#endif /* __grass_OperatorThreaded_h__ */

